unit Raten;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Spin;

type
  TZahlenRaten = class(TForm)
    Start: TButton;
    Auswahl: TRadioGroup;
    ButtonK: TButton;
    ButtonE: TButton;
    ButtonG: TButton;
    SpinEditVon: TSpinEdit;
    Label1: TLabel;
    SpinEditBis: TSpinEdit;
    Label2: TLabel;
    EditEA: TEdit;
    procedure AuswahlClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure EditEAKeyPress(Sender: TObject; var Key: Char);
    procedure StartClick(Sender: TObject);
    procedure Auswertung(Sender: TObject);
  private
    { Private-Deklarationen }
    von,bis,Versuch:Integer;
  public
    { Public-Deklarationen }
  end;

var
  ZahlenRaten: TZahlenRaten;

implementation

{$R *.dfm}

 procedure TZahlenRaten.AuswahlClick(Sender: TObject);
  begin
   if Auswahl.ItemIndex=0 then
    begin
     ButtonK.Visible:=True;
     ButtonE.Visible:=True;
     ButtonG.Visible:=True;
     EditEA.Enabled:=False;
    end;
   if Auswahl.ItemIndex=1 then
    begin
     ButtonK.Visible:=False;
     ButtonE.Visible:=False;
     ButtonG.Visible:=False;
     EditEA.Enabled:=True;
    end;
  end;

 procedure TZahlenRaten.FormCreate(Sender: TObject);
  begin
   Randomize;
  end;

 procedure TZahlenRaten.EditEAKeyPress(Sender: TObject; var Key: Char);
  var Zahl:Integer;
  begin
   if not(Key in['0'..'9',#8,#13]) then Key:=#0;
   if (Key=#13) and (EditEA.Text<>'') then
    begin
     Zahl:=StrToInt(EditEA.Text);
     if Zahl<Versuch then MessageDlg('zu klein!',mtConfirmation,[mbOk],0);
     if Zahl>Versuch then MessageDlg('zu gro!',mtConfirmation,[mbOk],0);
     if Zahl=Versuch then
      begin
       MessageDlg('Super, du hast die Zahl erraten!',mtInformation,[mbOk],0);
       Auswahl.Enabled:=True;
       SpinEditVon.Enabled:=True;
       SpinEditBis.Enabled:=True;
      end
    end
  end;

 procedure TZahlenRaten.StartClick(Sender: TObject);
  begin
   von:=SpinEditVon.Value;
   bis:=SpinEditBis.Value;
   Auswahl.Enabled:=False;
   SpinEditVon.Enabled:=False;
   SpinEditBis.Enabled:=False;
   if Auswahl.ItemIndex=0 then
    begin
     Versuch:=(von+bis)div 2;
     EditEA.Text:=IntToStr(Versuch);
    end;
   if Auswahl.ItemIndex=1 then
    begin
     Versuch:=random(bis-von+1)+von;
    end
  end;

 procedure TZahlenRaten.Auswertung(Sender: TObject);
  begin
   if Sender=ButtonE then
    begin
     MessageDlg('Der schlaue PC hat deine Zahl erraten!',mtInformation,[mbOk],0);
     Auswahl.Enabled:=True;
     SpinEditVon.Enabled:=True;
     SpinEditBis.Enabled:=True;
    end;
   if Sender=ButtonK then
    begin
     bis:=Versuch;
     Versuch:=(von+bis)div 2;
     EditEA.Text:=IntToStr(Versuch);
    end;
   if Sender=ButtonG then
    begin
     von:=Versuch;
     Versuch:=(von+bis)div 2;
     EditEA.Text:=IntToStr(Versuch);
    end;
  end;

end.
